/*
 * Copyright  2008 Nokia Corporation.
 */

#include "csvghandler.h"
#include "ctoolbarcontrol.h"
#include <mobilepaint.mbg>
#include <akniconutils.h>
#include <fbs.h>

_LIT(KSvgFile, "\\resource\\apps\\mobilepaint.mbm");


CSvgHandler::CSvgHandler ( )
    {
    }

CSvgHandler::~CSvgHandler ( )
    {
    delete iBarPortraitBitmap;
    delete iBarPortraitBitmapMask;

    delete iBarLandscapeBitmap;
    delete iBarLandscapeBitmapMask;
    
    delete iBarWideLandscapeBitmap;
    delete iBarWideLandscapeBitmapMask;

    delete iTooltipBitmap;
    delete iTooltipBitmapMask;
    
    delete iCircleButtonBitmap;
    delete iCircle2ButtonBitmap;
    delete iCircleButtonBitmapMask;
    delete iCircle2ButtonBitmapMask;

    delete iColorButtonBitmap;
    delete iColor2ButtonBitmap;
    delete iColorButtonBitmapMask;
    delete iColor2ButtonBitmapMask;

    delete iExitButtonBitmap;
    delete iExit2ButtonBitmap;
    delete iExitButtonBitmapMask;
    delete iExit2ButtonBitmapMask;

    delete iLineButtonBitmap;
    delete iLine2ButtonBitmap;
    delete iLineButtonBitmapMask;
    delete iLine2ButtonBitmapMask;

    delete iMenuButtonBitmap;
    delete iMenu2ButtonBitmap;
    delete iMenuButtonBitmapMask;
    delete iMenu2ButtonBitmapMask;

    delete iNewButtonBitmap;
    delete iNew2ButtonBitmap;
    delete iNewButtonBitmapMask;
    delete iNew2ButtonBitmapMask;

    delete iPenButtonBitmap;
    delete iPen2ButtonBitmap;
    delete iPenButtonBitmapMask;
    delete iPen2ButtonBitmapMask;

    delete iRectButtonBitmap;
    delete iRect2ButtonBitmap;
    delete iRectButtonBitmapMask;
    delete iRect2ButtonBitmapMask;

    delete iUndoButtonBitmap;
    delete iUndo2ButtonBitmap;
    delete iUndoButtonBitmapMask;
    delete iUndo2ButtonBitmapMask;
    
    delete iSplashScreenPortraitBitmap;
    delete iSplashScreenPortraitBitmapMask;
    
    delete iSplashScreenLandscapeBitmap;
    delete iSplashScreenLandscapeBitmapMask;
    
    delete iCBAPortraitBitmap;
    delete iCBAPortraitBitmapMask;
    
    delete iCBAPortraitFatBitmap;
    delete iCBAPortraitFatBitmapMask;
    
    delete iCBALandscapeBitmap;
    delete iCBALandscapeBitmapMask;
    
    delete iSize1ButtonBitmap;
    delete iSize1ButtonBitmapMask;
    delete iSize2ButtonBitmap;
    delete iSize2ButtonBitmapMask;
    delete iSize3ButtonBitmap;
    delete iSize3ButtonBitmapMask;
    delete iSize1DownButtonBitmap;
    delete iSize1DownButtonBitmapMask;
    delete iSize2DownButtonBitmap;
    delete iSize2DownButtonBitmapMask;
    delete iSize3DownButtonBitmap;
    delete iSize3DownButtonBitmapMask;
    }

CSvgHandler* CSvgHandler::NewLC ( )
    {
    CSvgHandler* self = new (ELeave)CSvgHandler();
    CleanupStack::PushL (self );
    self->ConstructL ( );
    return self;
    }

CSvgHandler* CSvgHandler::NewL ( )
    {
    CSvgHandler* self=CSvgHandler::NewLC ( );
    CleanupStack::Pop ( ); // self;
    return self;
    }

void CSvgHandler::ConstructL ( )
    {
    LoadBMPsL();
    LoadSVGsL();
    }

void CSvgHandler::LoadBMPsL()
    {
    // Portrait splash screen
    LoadIconL(KSvgFile, EMbmMobilepaintMobile_paint_splashscreen, iSplashScreenPortraitBitmap, TSize(SPLASH_SCREEN_WIDTH,SCREEN_HEIGHT));    

    // Landscape splash screen
    LoadIconL(KSvgFile, EMbmMobilepaintMobile_paint_splashscreen_landscape, iSplashScreenLandscapeBitmap, TSize(SCREEN_LANDSCAPE_WIDTH,SPLASH_SCREEN_LANDSCAPE_HEIGHT));    
    }

void CSvgHandler::LoadSVGsL()
    {
    TInt half_count = KToolbarItemCount/2;
    
    // Portrait toolbar 
    LoadIconL(KSvgFile, EMbmMobilepaintGraf_bar_portrait, iBarPortraitBitmap, iBarPortraitBitmapMask,
            TSize(KPortraitToolbarWidth,(KToolbarItemHeight*KToolbarItemCount) + KToolbarItemGap*(KToolbarItemCount+1)));    

    // Portrait fat toolbar
    LoadIconL(KSvgFile, EMbmMobilepaintGraf_bar_portrait_fat, iCBAPortraitFatBitmap, iCBAPortraitFatBitmapMask,
            TSize(KPortraitToolbarWidth2Rows,KToolbarItemHeight*half_count + KToolbarItemGap*(half_count)));    
        
    // Landscape fat toolbar 
    LoadIconL(KSvgFile, EMbmMobilepaintGraf_bar_landscape, iBarLandscapeBitmap, iBarLandscapeBitmapMask,
            TSize(KToolbarItemWidth*half_count + KToolbarItemGap*(half_count),KLandscapeToolbarHeight2Rows));    

    // Wide landscape toolbar
    LoadIconL(KSvgFile, EMbmMobilepaintGraf_bar_wide_landscape, iBarWideLandscapeBitmap, iBarWideLandscapeBitmapMask,
            TSize(KToolbarItemWidth*KToolbarItemCount + KToolbarItemGap*(KToolbarItemCount+1),KLandscapeToolbarHeight));    

    // CBA buttons background (terminal portrait)
    LoadIconL(KSvgFile, EMbmMobilepaintGraf_sk_buttonbar, iCBAPortraitBitmap, iCBAPortraitBitmapMask,
            TSize(KCBAPortraitWidth,KCBAPortraitHeight));    

    // CBA buttons background (terminal landscape)
    LoadIconL(KSvgFile, EMbmMobilepaintGraf_sk_buttonbar_landscape, iCBALandscapeBitmap, iCBALandscapeBitmapMask,
            TSize(KCBALandscapeWidth,KCBALandscapeHeight));    
    
    // Buttons
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_circle_pressed_38x38, iCircle2ButtonBitmap,iCircle2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_circle_unpressed_38x38, iCircleButtonBitmap,iCircleButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_color_pressed_38x38, iColor2ButtonBitmap, iColor2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_color_unpressed_38x38, iColorButtonBitmap,iColorButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    

    LoadIconL(KSvgFile, EMbmMobilepaintIcon_exit_pressed_38x38, iExit2ButtonBitmap, iExit2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_exit_unpressed_38x38, iExitButtonBitmap, iExitButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    

    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_pressed_38x38, iLine2ButtonBitmap, iLine2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_unpressed_38x38, iLineButtonBitmap, iLineButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_menu_pressed_38x38, iMenu2ButtonBitmap, iMenu2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_menu_unpressed_38x38, iMenuButtonBitmap,iMenuButtonBitmapMask,  TSize(KToolbarItemWidth,KToolbarItemHeight));    
    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_new_pressed_38x38, iNew2ButtonBitmap, iNew2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_new_unpressed_38x38, iNewButtonBitmap, iNewButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_pen_pressed_38x38, iPen2ButtonBitmap, iPen2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_pen_unpressed_38x38, iPenButtonBitmap, iPenButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_rectangle_pressed_38x38, iRect2ButtonBitmap, iRect2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_rectangle_unpressed_38x38, iRectButtonBitmap, iRectButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    

    LoadIconL(KSvgFile, EMbmMobilepaintIcon_undo_pressed_38x38, iUndo2ButtonBitmap, iUndo2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_undo_unpressed_38x38, iUndoButtonBitmap, iUndoButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    

    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_up_1st_selected_38x38, iSize1ButtonBitmap, iSize1ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_up_2nd_selected_38x38, iSize2ButtonBitmap, iSize2ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_up_3rd_selected_38x38, iSize3ButtonBitmap, iSize3ButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_down_1st_selected_38x38, iSize1DownButtonBitmap, iSize1DownButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_down_2nd_selected_38x38, iSize2DownButtonBitmap, iSize2DownButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    LoadIconL(KSvgFile, EMbmMobilepaintIcon_line_down_3rd_selected_38x38, iSize3DownButtonBitmap, iSize3DownButtonBitmapMask, TSize(KToolbarItemWidth,KToolbarItemHeight));    
    }

void CSvgHandler::LoadIconL(const TDesC& aIconFile, TInt aIndex, CFbsBitmap*& aBitmap, CFbsBitmap*& aMask, TSize aSize)
   {
   AknIconUtils::CreateIconL(aBitmap, aMask, aIconFile, aIndex, aIndex + 1);
   AknIconUtils::SetSize(aBitmap, aSize);
   AknIconUtils::SetSize(aMask, aSize);
   }

void CSvgHandler::LoadIconL(const TDesC& aIconFile, TInt aIndex, CFbsBitmap*& aBitmap, TSize aSize)
   {
   aBitmap = AknIconUtils::CreateIconL(aIconFile, aIndex);
   AknIconUtils::SetSize(aBitmap, aSize);
   }







